<?php
// $Id: comment_subject.token.inc,v 1.1 2009/11/19 07:54:59 sinasalek Exp $

function comment_subject_token_list($type = 'all') {
  if ($type == 'comment' || $type == 'all') {
    $tokens = array();

    $tokens['comment']['comment-pid']              = t('Comment\'s parent ID (just for parent being another comment, otherwise zero)');
    $tokens['comment']['comment-parent-title']     = t('Paren\'s title (the parent might be the node or a another comment)');
    $tokens['comment']['comment-parent-title-raw'] = t('Paren\'s title. WARNING - raw user input');
    $tokens['comment']['comment-auto-numbering']   = t('Auto-numbering with respect to node\'s comments count');
    
    return $tokens;
  }
}

function comment_subject_token_values($type, $object = NULL) {
  static $comments_count_cache = array();
  
  if ($type == 'comment') {
    $comment = (object)$object;
    // @TODO: support uninitialized pid? (forms might have it uninitialized)
    if (!isset($comment->pid)) $comment->pid = 0;
    
    // [comment-parent-title]
    if ($comment->pid) { 
      $parent = _comment_load($comment->pid);
      $parent_title = $parent->subject;
    }
    else {
      $parent = node_load($comment->nid);
      $parent_title = $parent->title;
    }
    
    // [comment-auto-numbering]
    if (isset($comment->cid)) {
      if (!isset($comments_count_cache[$comment->cid])) {
        $query = 'SELECT COUNT(cid) FROM {comments} WHERE nid = %d AND cid < %d ORDER BY cid ASC';
        $comments_count_cache[$comment->cid] = db_result(db_query($query, $comment->nid, $comment->cid));
      }
      $comments_count = $comments_count_cache[$comment->cid];
    }
    else {
      $comments_count = comment_num_all($comment->nid);
    }
    
    $tokens['comment-pid']              = $comment->pid;
    $tokens['comment-parent-title']     = check_plain($parent_title);
    $tokens['comment-parent-title-raw'] = $parent_title;
    $tokens['comment-auto-numbering']   = ($comments_count + 1);
    
    return $tokens;
  }
}
